Index: /trunk/greenstone3-extensions/gsdl-as/build.xml
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/build.xml	(revision 8643)
+++ /trunk/greenstone3-extensions/gsdl-as/build.xml	(revision 8644)
@@ -111,5 +111,5 @@
 
   <property name="app.name"      value="gsdl-as"/>
-  <property name="app.path"      value="/${app.name}"/>
+  <property name="app.path"      value="/alerting"/>
   <property name="app.version"   value="0.1-dev"/>
   <property name="build.home"    value="${basedir}/build"/>
Index: /trunk/greenstone3-extensions/gsdl-as/descriptor.xml
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/descriptor.xml	(revision 8644)
+++ /trunk/greenstone3-extensions/gsdl-as/descriptor.xml	(revision 8644)
@@ -0,0 +1,7 @@
+<isd:service
+  xmlns:isd="http://xml.apache.org/xml-soap/deployment"
+  id="alerting" checkMustUnderstands="false">
+  <isd:provider type="java" scope="Session" methods="receiveEvent">
+    <isd:java class="org.greenstone.gsdlas.AlertingService" static="false"/>
+  </isd:provider>
+</isd:service>
Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8643)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8644)
@@ -143,5 +143,5 @@
     }
     
-    public void receive(Map event) {
+    public void receiveEvent(Map event) {
         GreenstoneCommunicator gsComm = null;
         try {
Index: /trunk/greenstone3-extensions/gsdl-as/web/index.html
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/web/index.html	(revision 8643)
+++ /trunk/greenstone3-extensions/gsdl-as/web/index.html	(revision 8644)
@@ -34,4 +34,5 @@
 	
 	<tr><td><a href="test.html">Test</a> the alerting service servlet.</td></tr>
+	<tr><td><a href="service?action=listSubscriptions">List</a> the existing subscriptions.</td></tr>
 	<tr><td><a href="about.html">Read more</a> about the alerting service.</td></tr>
 		
Index: /trunk/greenstone3-extensions/gsdl-as/web/test.html
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/web/test.html	(revision 8643)
+++ /trunk/greenstone3-extensions/gsdl-as/web/test.html	(revision 8644)
@@ -16,10 +16,10 @@
 		<form action="/alerting/service?test" method="POST">
 			<input type="text" name="text"/><br/>
-			<input type="submit"/>
+			<input type="submit" value="submit"/>
 		</form>
 		<hr/>
 		
 		<h1>Subscribe</h1>
-		<form action="/alerting/service" method ="GET" name="subscribe">
+		<form action="/alerting/service" method="POST" name="subscribe">
 			<input type="hidden" name="action" value="subscribe"/>
 			<table border="1">
@@ -57,13 +57,7 @@
 					</td>
 				</tr>
-				<tr>
-					<th>Collection Name</th>
-					<td>
-					  <input type="text" name="collection_name"/>
-					</td>
-				</tr>
 			</table>
 			<br/>
-			<input type="submit"/>
+			<input type="submit" value="submit"/>
 		</form>
 	</body>
Index: /trunk/gsdl3/extensions/gsdl-as/build.xml
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/build.xml	(revision 8643)
+++ /trunk/gsdl3/extensions/gsdl-as/build.xml	(revision 8644)
@@ -111,5 +111,5 @@
 
   <property name="app.name"      value="gsdl-as"/>
-  <property name="app.path"      value="/${app.name}"/>
+  <property name="app.path"      value="/alerting"/>
   <property name="app.version"   value="0.1-dev"/>
   <property name="build.home"    value="${basedir}/build"/>
Index: /trunk/gsdl3/extensions/gsdl-as/descriptor.xml
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/descriptor.xml	(revision 8644)
+++ /trunk/gsdl3/extensions/gsdl-as/descriptor.xml	(revision 8644)
@@ -0,0 +1,7 @@
+<isd:service
+  xmlns:isd="http://xml.apache.org/xml-soap/deployment"
+  id="alerting" checkMustUnderstands="false">
+  <isd:provider type="java" scope="Session" methods="receiveEvent">
+    <isd:java class="org.greenstone.gsdlas.AlertingService" static="false"/>
+  </isd:provider>
+</isd:service>
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8643)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8644)
@@ -143,5 +143,5 @@
     }
     
-    public void receive(Map event) {
+    public void receiveEvent(Map event) {
         GreenstoneCommunicator gsComm = null;
         try {
Index: /trunk/gsdl3/extensions/gsdl-as/web/index.html
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/web/index.html	(revision 8643)
+++ /trunk/gsdl3/extensions/gsdl-as/web/index.html	(revision 8644)
@@ -34,4 +34,5 @@
 	
 	<tr><td><a href="test.html">Test</a> the alerting service servlet.</td></tr>
+	<tr><td><a href="service?action=listSubscriptions">List</a> the existing subscriptions.</td></tr>
 	<tr><td><a href="about.html">Read more</a> about the alerting service.</td></tr>
 		
Index: /trunk/gsdl3/extensions/gsdl-as/web/test.html
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/web/test.html	(revision 8643)
+++ /trunk/gsdl3/extensions/gsdl-as/web/test.html	(revision 8644)
@@ -16,10 +16,10 @@
 		<form action="/alerting/service?test" method="POST">
 			<input type="text" name="text"/><br/>
-			<input type="submit"/>
+			<input type="submit" value="submit"/>
 		</form>
 		<hr/>
 		
 		<h1>Subscribe</h1>
-		<form action="/alerting/service" method ="GET" name="subscribe">
+		<form action="/alerting/service" method="POST" name="subscribe">
 			<input type="hidden" name="action" value="subscribe"/>
 			<table border="1">
@@ -57,13 +57,7 @@
 					</td>
 				</tr>
-				<tr>
-					<th>Collection Name</th>
-					<td>
-					  <input type="text" name="collection_name"/>
-					</td>
-				</tr>
 			</table>
 			<br/>
-			<input type="submit"/>
+			<input type="submit" value="submit"/>
 		</form>
 	</body>
Index: /trunk/gsdl3/packages/gsdl-as/build.xml
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/build.xml	(revision 8643)
+++ /trunk/gsdl3/packages/gsdl-as/build.xml	(revision 8644)
@@ -111,5 +111,5 @@
 
   <property name="app.name"      value="gsdl-as"/>
-  <property name="app.path"      value="/${app.name}"/>
+  <property name="app.path"      value="/alerting"/>
   <property name="app.version"   value="0.1-dev"/>
   <property name="build.home"    value="${basedir}/build"/>
Index: /trunk/gsdl3/packages/gsdl-as/descriptor.xml
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/descriptor.xml	(revision 8644)
+++ /trunk/gsdl3/packages/gsdl-as/descriptor.xml	(revision 8644)
@@ -0,0 +1,7 @@
+<isd:service
+  xmlns:isd="http://xml.apache.org/xml-soap/deployment"
+  id="alerting" checkMustUnderstands="false">
+  <isd:provider type="java" scope="Session" methods="receiveEvent">
+    <isd:java class="org.greenstone.gsdlas.AlertingService" static="false"/>
+  </isd:provider>
+</isd:service>
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8643)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8644)
@@ -143,5 +143,5 @@
     }
     
-    public void receive(Map event) {
+    public void receiveEvent(Map event) {
         GreenstoneCommunicator gsComm = null;
         try {
Index: /trunk/gsdl3/packages/gsdl-as/web/index.html
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/web/index.html	(revision 8643)
+++ /trunk/gsdl3/packages/gsdl-as/web/index.html	(revision 8644)
@@ -34,4 +34,5 @@
 	
 	<tr><td><a href="test.html">Test</a> the alerting service servlet.</td></tr>
+	<tr><td><a href="service?action=listSubscriptions">List</a> the existing subscriptions.</td></tr>
 	<tr><td><a href="about.html">Read more</a> about the alerting service.</td></tr>
 		
Index: /trunk/gsdl3/packages/gsdl-as/web/test.html
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/web/test.html	(revision 8643)
+++ /trunk/gsdl3/packages/gsdl-as/web/test.html	(revision 8644)
@@ -16,10 +16,10 @@
 		<form action="/alerting/service?test" method="POST">
 			<input type="text" name="text"/><br/>
-			<input type="submit"/>
+			<input type="submit" value="submit"/>
 		</form>
 		<hr/>
 		
 		<h1>Subscribe</h1>
-		<form action="/alerting/service" method ="GET" name="subscribe">
+		<form action="/alerting/service" method="POST" name="subscribe">
 			<input type="hidden" name="action" value="subscribe"/>
 			<table border="1">
@@ -57,13 +57,7 @@
 					</td>
 				</tr>
-				<tr>
-					<th>Collection Name</th>
-					<td>
-					  <input type="text" name="collection_name"/>
-					</td>
-				</tr>
 			</table>
 			<br/>
-			<input type="submit"/>
+			<input type="submit" value="submit"/>
 		</form>
 	</body>