Index: trunk/gsdl/src/mgpp/text/QueryTester.cpp
===================================================================
--- trunk/gsdl/src/mgpp/text/QueryTester.cpp	(revision 2468)
+++ trunk/gsdl/src/mgpp/text/QueryTester.cpp	(revision 8691)
@@ -49,24 +49,24 @@
   DocNumArray &docSet1 = setNode1->queryResult.docs;
   RankArray &rankSet1 = setNode1->queryResult.ranks;
-  docSet1.push_back (1);  rankSet1.push_back (0.1);
-  docSet1.push_back (10); rankSet1.push_back (0.2);
-  docSet1.push_back (15); rankSet1.push_back (0.2);
-  docSet1.push_back (18); rankSet1.push_back (0.4);
-  docSet1.push_back (19); rankSet1.push_back (0.5);
+  docSet1.push_back (1);  rankSet1.push_back (0.1f);
+  docSet1.push_back (10); rankSet1.push_back (0.2f);
+  docSet1.push_back (15); rankSet1.push_back (0.2f);
+  docSet1.push_back (18); rankSet1.push_back (0.4f);
+  docSet1.push_back (19); rankSet1.push_back (0.5f);
 
   SetQueryNode *setNode2 = new SetQueryNode;
   DocNumArray &docSet2 = setNode2->queryResult.docs;
   RankArray &rankSet2 = setNode2->queryResult.ranks;
-  docSet2.push_back (2);  rankSet2.push_back (0.1);
-  docSet2.push_back (11); rankSet2.push_back (0.2);
-  docSet2.push_back (12); rankSet2.push_back (0.3);
-  docSet2.push_back (13); rankSet2.push_back (0.4);
-  docSet2.push_back (14); rankSet2.push_back (0.5);
-  docSet2.push_back (15); rankSet2.push_back (0.6);
-  docSet2.push_back (16); rankSet2.push_back (0.7);
-  docSet2.push_back (17); rankSet2.push_back (0.8);
-  docSet2.push_back (19); rankSet2.push_back (0.9);
-  docSet2.push_back (20); rankSet2.push_back (0.1);
-  docSet2.push_back (21); rankSet2.push_back (0.2);
+  docSet2.push_back (2);  rankSet2.push_back (0.1f);
+  docSet2.push_back (11); rankSet2.push_back (0.2f);
+  docSet2.push_back (12); rankSet2.push_back (0.3f);
+  docSet2.push_back (13); rankSet2.push_back (0.4f);
+  docSet2.push_back (14); rankSet2.push_back (0.5f);
+  docSet2.push_back (15); rankSet2.push_back (0.6f);
+  docSet2.push_back (16); rankSet2.push_back (0.7f);
+  docSet2.push_back (17); rankSet2.push_back (0.8f);
+  docSet2.push_back (19); rankSet2.push_back (0.9f);
+  docSet2.push_back (20); rankSet2.push_back (0.1f);
+  docSet2.push_back (21); rankSet2.push_back (0.2f);
 
   cout << "\n" << setNode1->queryResult << "AND\n\n"
@@ -170,24 +170,24 @@
   DocNumArray &docSet1 = setNode1->queryResult.docs;
   RankArray &rankSet1 = setNode1->queryResult.ranks;
-  docSet1.push_back (1);  rankSet1.push_back (0.1);
-  docSet1.push_back (10); rankSet1.push_back (0.2);
-  docSet1.push_back (15); rankSet1.push_back (0.2);
-  docSet1.push_back (18); rankSet1.push_back (0.4);
-  docSet1.push_back (19); rankSet1.push_back (0.5);
+  docSet1.push_back (1);  rankSet1.push_back (0.1f);
+  docSet1.push_back (10); rankSet1.push_back (0.2f);
+  docSet1.push_back (15); rankSet1.push_back (0.2f);
+  docSet1.push_back (18); rankSet1.push_back (0.4f);
+  docSet1.push_back (19); rankSet1.push_back (0.5f);
 
   SetQueryNode *setNode2 = new SetQueryNode;
   DocNumArray &docSet2 = setNode2->queryResult.docs;
   RankArray &rankSet2 = setNode2->queryResult.ranks;
-  docSet2.push_back (2);  rankSet2.push_back (0.1);
-  docSet2.push_back (11); rankSet2.push_back (0.2);
-  docSet2.push_back (12); rankSet2.push_back (0.3);
-  docSet2.push_back (13); rankSet2.push_back (0.4);
-  docSet2.push_back (14); rankSet2.push_back (0.5);
-  docSet2.push_back (15); rankSet2.push_back (0.6);
-  docSet2.push_back (16); rankSet2.push_back (0.7);
-  docSet2.push_back (17); rankSet2.push_back (0.8);
-  docSet2.push_back (19); rankSet2.push_back (0.9);
-  docSet2.push_back (20); rankSet2.push_back (0.1);
-  docSet2.push_back (21); rankSet2.push_back (0.2);
+  docSet2.push_back (2);  rankSet2.push_back (0.1f);
+  docSet2.push_back (11); rankSet2.push_back (0.2f);
+  docSet2.push_back (12); rankSet2.push_back (0.3f);
+  docSet2.push_back (13); rankSet2.push_back (0.4f);
+  docSet2.push_back (14); rankSet2.push_back (0.5f);
+  docSet2.push_back (15); rankSet2.push_back (0.6f);
+  docSet2.push_back (16); rankSet2.push_back (0.7f);
+  docSet2.push_back (17); rankSet2.push_back (0.8f);
+  docSet2.push_back (19); rankSet2.push_back (0.9f);
+  docSet2.push_back (20); rankSet2.push_back (0.1f);
+  docSet2.push_back (21); rankSet2.push_back (0.2f);
 
   cout << "\n" << setNode1->queryResult << "OR\n\n"
@@ -214,18 +214,18 @@
   DocNumArray &rcDocSet = resultCompare.docs;
   RankArray &rcRankSet = resultCompare.ranks;
-  rcDocSet.push_back (1);  rcRankSet.push_back (0.1);
-  rcDocSet.push_back (2);  rcRankSet.push_back (0.1);
-  rcDocSet.push_back (10); rcRankSet.push_back (0.2);
-  rcDocSet.push_back (11); rcRankSet.push_back (0.2);
-  rcDocSet.push_back (12); rcRankSet.push_back (0.3);
-  rcDocSet.push_back (13); rcRankSet.push_back (0.4);
-  rcDocSet.push_back (14); rcRankSet.push_back (0.5);
-  rcDocSet.push_back (15); rcRankSet.push_back (0.2+0.6);
-  rcDocSet.push_back (16); rcRankSet.push_back (0.7);
-  rcDocSet.push_back (17); rcRankSet.push_back (0.8);
-  rcDocSet.push_back (18); rcRankSet.push_back (0.4);
-  rcDocSet.push_back (19); rcRankSet.push_back (0.9+0.5);
-  rcDocSet.push_back (20); rcRankSet.push_back (0.1);
-  rcDocSet.push_back (21); rcRankSet.push_back (0.2);
+  rcDocSet.push_back (1);  rcRankSet.push_back (0.1f);
+  rcDocSet.push_back (2);  rcRankSet.push_back (0.1f);
+  rcDocSet.push_back (10); rcRankSet.push_back (0.2f);
+  rcDocSet.push_back (11); rcRankSet.push_back (0.2f);
+  rcDocSet.push_back (12); rcRankSet.push_back (0.3f);
+  rcDocSet.push_back (13); rcRankSet.push_back (0.4f);
+  rcDocSet.push_back (14); rcRankSet.push_back (0.5f);
+  rcDocSet.push_back (15); rcRankSet.push_back (0.2f+0.6f);
+  rcDocSet.push_back (16); rcRankSet.push_back (0.7f);
+  rcDocSet.push_back (17); rcRankSet.push_back (0.8f);
+  rcDocSet.push_back (18); rcRankSet.push_back (0.4f);
+  rcDocSet.push_back (19); rcRankSet.push_back (0.9f+0.5f);
+  rcDocSet.push_back (20); rcRankSet.push_back (0.1f);
+  rcDocSet.push_back (21); rcRankSet.push_back (0.2f);
   
 
@@ -317,24 +317,24 @@
   DocNumArray &docSet1 = setNode1->queryResult.docs;
   RankArray &rankSet1 = setNode1->queryResult.ranks;
-  docSet1.push_back (1);  rankSet1.push_back (0.1);
-  docSet1.push_back (10); rankSet1.push_back (0.2);
-  docSet1.push_back (15); rankSet1.push_back (0.2);
-  docSet1.push_back (18); rankSet1.push_back (0.4);
-  docSet1.push_back (19); rankSet1.push_back (0.5);
+  docSet1.push_back (1);  rankSet1.push_back (0.1f);
+  docSet1.push_back (10); rankSet1.push_back (0.2f);
+  docSet1.push_back (15); rankSet1.push_back (0.2f);
+  docSet1.push_back (18); rankSet1.push_back (0.4f);
+  docSet1.push_back (19); rankSet1.push_back (0.5f);
 
   SetQueryNode *setNode2 = new SetQueryNode;
   DocNumArray &docSet2 = setNode2->queryResult.docs;
   RankArray &rankSet2 = setNode2->queryResult.ranks;
-  docSet2.push_back (2);  rankSet2.push_back (0.1);
-  docSet2.push_back (11); rankSet2.push_back (0.2);
-  docSet2.push_back (12); rankSet2.push_back (0.3);
-  docSet2.push_back (13); rankSet2.push_back (0.4);
-  docSet2.push_back (14); rankSet2.push_back (0.5);
-  docSet2.push_back (15); rankSet2.push_back (0.6);
-  docSet2.push_back (16); rankSet2.push_back (0.7);
-  docSet2.push_back (17); rankSet2.push_back (0.8);
-  docSet2.push_back (19); rankSet2.push_back (0.9);
-  docSet2.push_back (20); rankSet2.push_back (0.1);
-  docSet2.push_back (21); rankSet2.push_back (0.2);
+  docSet2.push_back (2);  rankSet2.push_back (0.1f);
+  docSet2.push_back (11); rankSet2.push_back (0.2f);
+  docSet2.push_back (12); rankSet2.push_back (0.3f);
+  docSet2.push_back (13); rankSet2.push_back (0.4f);
+  docSet2.push_back (14); rankSet2.push_back (0.5f);
+  docSet2.push_back (15); rankSet2.push_back (0.6f);
+  docSet2.push_back (16); rankSet2.push_back (0.7f);
+  docSet2.push_back (17); rankSet2.push_back (0.8f);
+  docSet2.push_back (19); rankSet2.push_back (0.9f);
+  docSet2.push_back (20); rankSet2.push_back (0.1f);
+  docSet2.push_back (21); rankSet2.push_back (0.2f);
 
   cout << "\n" << setNode1->queryResult << "NOT\n\n"