Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8774)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8775)
@@ -379,5 +379,5 @@
      * @param page
      * @param session
-     * @return TODO
+     * @return 
      */
     private Map getPageArgsFromSession(String page, HttpSession session) {
Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java	(revision 8774)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java	(revision 8775)
@@ -143,4 +143,5 @@
             String docID = node.getAttributes().getNamedItem("nodeID").getNodeValue();
             // TODO what about the nodeType
+            // TODO make sure to pass IDs of whole documents, not of parts of docs
             result.add(docID);
         }
Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java	(revision 8774)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java	(revision 8775)
@@ -47,5 +47,4 @@
     public void addSubscription(int subscriptionID) {
         subscriptions.add(new Integer(subscriptionID));
-        // TODO save to db
     }
 
Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java	(revision 8774)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 3, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.users;
Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java	(revision 8774)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 3, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.users;
Index: /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java
===================================================================
--- /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java	(revision 8774)
+++ /trunk/greenstone3-extensions/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 5, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.util;
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8774)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8775)
@@ -379,5 +379,5 @@
      * @param page
      * @param session
-     * @return TODO
+     * @return 
      */
     private Map getPageArgsFromSession(String page, HttpSession session) {
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java	(revision 8774)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java	(revision 8775)
@@ -143,4 +143,5 @@
             String docID = node.getAttributes().getNamedItem("nodeID").getNodeValue();
             // TODO what about the nodeType
+            // TODO make sure to pass IDs of whole documents, not of parts of docs
             result.add(docID);
         }
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java	(revision 8774)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java	(revision 8775)
@@ -47,5 +47,4 @@
     public void addSubscription(int subscriptionID) {
         subscriptions.add(new Integer(subscriptionID));
-        // TODO save to db
     }
 
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java	(revision 8774)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 3, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.users;
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java	(revision 8774)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 3, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.users;
Index: /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java
===================================================================
--- /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java	(revision 8774)
+++ /trunk/gsdl3/extensions/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 5, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.util;
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8774)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/AlertingService.java	(revision 8775)
@@ -379,5 +379,5 @@
      * @param page
      * @param session
-     * @return TODO
+     * @return 
      */
     private Map getPageArgsFromSession(String page, HttpSession session) {
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java	(revision 8774)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/GreenstoneCommunicator.java	(revision 8775)
@@ -143,4 +143,5 @@
             String docID = node.getAttributes().getNamedItem("nodeID").getNodeValue();
             // TODO what about the nodeType
+            // TODO make sure to pass IDs of whole documents, not of parts of docs
             result.add(docID);
         }
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java	(revision 8774)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/profiles/Predicate.java	(revision 8775)
@@ -47,5 +47,4 @@
     public void addSubscription(int subscriptionID) {
         subscriptions.add(new Integer(subscriptionID));
-        // TODO save to db
     }
 
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java	(revision 8774)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/users/PasswordMismatchException.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 3, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.users;
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java	(revision 8774)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/users/UserManagementException.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 3, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.users;
Index: /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java
===================================================================
--- /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java	(revision 8774)
+++ /trunk/gsdl3/packages/gsdl-as/src/org/greenstone/gsdlas/util/ArrayHelper.java	(revision 8775)
@@ -1,7 +1,9 @@
 /*
  * Created on Dec 5, 2004
+ * Copyright (C) Andrea Schweer, 2004
  *
- * TODO To change the template for this generated file go to
- * Window - Preferences - Java - Code Style - Code Templates
+ * This file is part of the Greenstone Alerting Service.
+ * Refer to the COPYING file in the base directory of this package
+ * for licensing information.
  */
 package org.greenstone.gsdlas.util;